// Feb 2014 - block game engine - code by Emperor Katax 
window.onload = function () {
			var canvas = document.getElementById('canvas'),
			context = canvas.getContext('2d'),
			mouse = utils.captureMouse(canvas),
			touch = utils.captureTouch(canvas);
			
			activeItem_id = 0;
			///// message
			context.font = '32pt Arial';
			context.fillStyle = 'blue';
			////////////////////////////////////////////
			// file data
			var fileNames = new FileData();
			// add fridge image data 
			var fridge_image = new Array();
			fridge_image[0] = new FridgeManager(fileNames.getData("home"));
			fridge_image[0].x = 450;
			fridge_image[0].y = 100;
			// block items
			var drag_item = new Array();
			var drag_maxItems = fileNames.block_max;
			for (var i = 0; i < drag_maxItems; i++){
				drag_item[i] = new DragItem(fileNames.getData("item"),fileNames.getData("coord"), i);
				//drag_item[i].x = (drag_iteratorX * 200) + 25;
				//drag_item[i].y = 100 + (200 * drag_iteratorY);
				
				//drag_item[i].x = 450 + ( (drag_item[i].coord % 6) * 60);
				//drag_item[i].y = 100 + ( Math.floor(drag_item[i].coord / 6) * 60);
				
				drag_item[i].x = 40 + ( (drag_item[i].coord % 6) * 60); // shift 40 pix **
				drag_item[i].y = 100 + ( Math.floor(drag_item[i].coord / 6) * 60);
				
				drag_item[i].first_x = drag_item[i].x;
				drag_item[i].first_y = drag_item[i].y;
				
				drag_item[i].destX = drag_item[i].x + 450 - 40; // unshift 40 pix **
				drag_item[i].destY = drag_item[i].y;
			}
			var drag_currentBlockID = 0;		// current id of draged item
			var drag_action = false;				// check for drag true: in progress / false: no drag
			
			// add fridge image data 
			var fridge_image = new Array();
			fridge_image[0] = new FridgeManager(fileNames.getData("home"));
			fridge_image[0].x = 450;
			fridge_image[0].y = 100;
			
			// touch
			var isTouch = !!("undefined" != typeof document.documentElement.ontouchstart); // test - 24
			var player_Xbuffer_touch = 0;											// buffer current player x on touch
			var player_Ybuffer_touch = 0;											// buffer current player y on touch
			// test message vars
			var tempX = 0;
			var tempY = 0;
			
			//////////////----------////////////////////
			//////////////----------////////////////////
			// mouse detection
			canvas.addEventListener('mousedown', function () {
			
			if ( !touch.isPressed && !isTouch){
				for (var i = 0; i < drag_maxItems; i++){
					if (utils.containsPoint(drag_item[i].getBounds(), mouse.x, mouse.y) && !drag_item[i].fixed) {
						canvas.addEventListener('mouseup', onMouseUp, false);
						canvas.addEventListener('mousemove', onMouseMove, false);
						activeItem_id = i; 																										// save clicked item id
						drag_item[activeItem_id].correctBoundsXY(mouse.x, mouse.y);	// get correct coordination for drag
					}
				}
			}
			
			}, false);
			
			function onMouseUp () {
				checkMatch(drag_item[activeItem_id]);
				//drag_item[activeItem_id].x = drag_item[activeItem_id].first_x;
				//drag_item[activeItem_id].y = drag_item[activeItem_id].first_y;
				drag_action = false;
				canvas.removeEventListener('mouseup', onMouseUp, false);
				canvas.removeEventListener('mousemove', onMouseMove, false);
			}
			
			function onMouseMove (event) {
				// cordination 
				drag_item[activeItem_id].x = mouse.x - drag_item[activeItem_id].getCorrectBounds(1);
				drag_item[activeItem_id].y = mouse.y - drag_item[activeItem_id].getCorrectBounds(0);
				drag_currentBlockID = drag_item[activeItem_id].id; 
				drag_action = true;
			}
			//////////////----------////////////////////
			//////////////----------////////////////////
			
			/////////////////////////////////////////////////////////////
			///////////////////////////touch//////////////////////////////////
			canvas.addEventListener('touchstart',  function () {
				if (isTouch){
					for (var i = 0; i < drag_maxItems; i++){
						if (utils.containsPoint(drag_item[i].getBounds(), touch.x, touch.y) && !drag_item[i].fixed) {
							canvas.addEventListener('touchmove', onTouchMove, false);
							canvas.addEventListener('touchend', onTouchEnd, false);
							activeItem_id = i; 																										// save clicked item id
							drag_item[activeItem_id].correctBoundsXY(touch.x, touch.y);	// get correct coordination for drag
						}
					}
				}
			}, false);
			
			function onTouchMove (event) {
				event.preventDefault(); // stop scrolling on touch move
				// cordination 
				drag_item[activeItem_id].x = touch.x - drag_item[activeItem_id].getCorrectBounds(1);
				drag_item[activeItem_id].y = touch.y - drag_item[activeItem_id].getCorrectBounds(0);
				drag_currentBlockID = drag_item[activeItem_id].id; 
				drag_action = true;
			}
			function onTouchEnd (event) {
				checkMatch(drag_item[activeItem_id]);
				//drag_item[activeItem_id].x = drag_item[activeItem_id].first_x;
				//drag_item[activeItem_id].y = drag_item[activeItem_id].first_y;
				drag_action = false;
				canvas.removeEventListener('touchmove', onTouchMove, false);
				canvas.removeEventListener('touchend', onTouchEnd, false);
			}
			/////////////////////////////////////////////////////////////
			/////////////////////////////////////////////////////////////
			
			// check matching blocks
			function checkMatch (daragItem_object) {
				if ( (utils.containsPoint(daragItem_object.getBounds(), daragItem_object.destX, daragItem_object.destY))&& drag_action) {
					daragItem_object.x = daragItem_object.destX;
					daragItem_object.y = daragItem_object.destY;
					daragItem_object.fixed = true;
				}
			}
			// drawing 
			(function drawFrame () {
				window.requestAnimationFrame(drawFrame, canvas);
				context.clearRect(0, 0, canvas.width, canvas.height);

				// draw items
				fridge_image[0].draw(context);																										// fridge image
				for (var i = 0; i < drag_maxItems; i++)	drag_item[i].draw(context);		// block item images
				for (var i = 0; i < drag_maxItems; i++)	drag_item[i].draw_nav(context);		// block item images
				
				//////////////////// text /////////////////////////
				if (true){
						context.font = '32pt Arial';
						context.fillStyle = 'blue';
						if (!isTouch){ 
							context.fillText(  ">mouse:   " + mouse.x + " | " + mouse.y , mouse.x, mouse.y + 120);
							tempX = mouse.x;
							tempY = mouse.y;
						}else{
							tempX = touch.x;
							tempY = touch.y;
						}
					if ( (utils.containsPoint(fridge_image[0].getBounds(), tempX, tempY))&& drag_action) {
						//context.fillText("inside fridge: block item " + drag_currentBlockID , canvas.width / 5, 50); // message
						context.fillText(">inside fridge: block item " + (drag_currentBlockID + 1) , 154, 50); // test message
					}else{
						//context.fillText(">inside fridge: no item " , 154, 50); // test message
					}
				}
				//////////////////////////////////////////////////
				
				// message and timing functionality
			

			}());
			};